<template>
	<div class="glossary-tab-content">
		<div class="catalog-page"> 
            <FiltersTop :data="synonymData">
                <button class="button-stroke-transparent" @click="showCreateTermModal = true">Add
					Term</button>
				<div class="filters-top-totals"><b>{{ totalTermsCount }} Term(s)</b> available
				</div>
            </FiltersTop>
			<DatatableTerms :data="synonymData" type="Synonym" @open-edit-modal="handleOpenEditModal"></DatatableTerms>
            <DatatableTerms :data="antonymData" type="Antonym" @open-edit-modal="handleOpenEditModal"></DatatableTerms>
		</div>
	</div>
	<ClientOnly>
		<Teleport to="#modals-container">
			<ModalsCreateTerm v-if="showCreateTermModal" @toggle="close" :isEditMode="isEditMode" :row="selectedRow ? selectedRow : ''" />
		</Teleport>
	</ClientOnly>
</template>

<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';

const props = defineProps({
	glossaryData: {
		type: Object,
		default: () => ({ synonyms: [], antonyms: [] })
	}
}); 

interface Terms {
    id: number;
    name: string;
    type: string;
    domains: any;
    description: string;
	summary: string;
    updatedAt: string;
    createdAt: string;
}

// Helper to map data
const mapRows = async function(data: Terms[], type: string) {

    const rows = data.map((term: Terms) => ({
		id: term.id,
		name: term.name,
		type: 'Term',
		domains: '',
		description: term.description,
		summary: term.summary,
		edited_at: formatDate(term?.updatedAt),
		created_at: formatDate(term?.createdAt),
		actions: ''
	}));

	const detailedRows = await Promise.all(
		data?.map(async (term: Terms) => {
			try {
			const details = await useFetchAuth(`/terms/${term.id}`) as Terms;
			
			return {
				id: term.id,
                name: term.name,
                type: 'Term',
                domains: '',
                description: details.description,
                summary: details.summary,
                edited_at: formatDate(details?.updatedAt),
                created_at: formatDate(details?.createdAt),
                actions: ''
				
			};
			} catch (error) {
				return {
					id: term.id,
                    name: term.name,
                    type: 'Term',
                    domains: '',
                    description: '',
                    summary: '',
                    edited_at: '',
                    created_at: '',
                    actions: ''
				};
			}
		})
	);

	return detailedRows;
}

// Synonyms data
const synonymData = ref<DataTableI>({
	options: {
		tableName: 'synonyms-table',
		detailsPath: '/glossary/terms/',
		allowCheckRow: true,
		favourites: true,
		previewComponent: 'TermsDetails',
	},
	columns: [
		{ id: 1, name: 'name', label: 'Name', combineColumn: 'type', renderComponent: 'TableColumnsName' },
		{ id: 4, name: 'summary', label: 'Description', width: '60%' },
		{ id: 6, name: 'actions', label: 'Actions', width: '80px', hideLabel: true }
	],
	rows: []
});

// Antonyms data
const antonymData = ref<DataTableI>({
	options: {
		tableName: 'antonyms-table',
		detailsPath: '/glossary/terms/',
		allowCheckRow: true,
		favourites: true,
		previewComponent: 'TermsDetails',
	},
	columns: [
		{ id: 1, name: 'name', label: 'Name', combineColumn: 'type', renderComponent: 'TableColumnsName' },
		{ id: 4, name: 'summary', label: 'Description', width: '60%' },
		{ id: 6, name: 'actions', label: 'Actions', width: '80px', hideLabel: true }
	],
	rows: []
});

// Populate rows
async function populateRows() {
    try {
        if (props?.glossaryData?.synonyms?.length) {
            synonymData.value.rows = await mapRows(props?.glossaryData?.synonyms, 'Synonym');
        }
        if (props?.glossaryData?.antonyms?.length) {
            antonymData.value.rows = await mapRows(props?.glossaryData?.antonyms, 'Antonym');
        }
    } catch (error) {
        console.error('Error populating rows:', error);
    }
}

onMounted(async () => {
    await populateRows();
});

watch(
	() => props.glossaryData,
	() => {
		populateRows();
	},
	{ deep: true }
);

const totalTermsCount = computed(() => {
    const synonymRows = synonymData.value?.rows ?? [];
    const antonymRows = antonymData.value?.rows ?? [];
    return synonymRows.length + antonymRows.length;
});

const showCreateTermModal = ref(false);
const showCreateGlossaryModal = ref(false);
const selectedRow = ref(null);
const isEditMode = ref(false);

const handleOpenEditModal = (row: any) => {
    selectedRow.value = row?.id; // Pass the selected row data to the modal
    isEditMode.value = true;
    showCreateTermModal.value = true; // Open the Edit Dataset modal
};

const close = () => {
	if(showCreateTermModal){
		showCreateTermModal.value = false;
	}
	if(showCreateGlossaryModal){
		showCreateGlossaryModal.value = false;
		isEditMode.value = false;
	}
};

</script>